<template>
  <div>
    <!-- Domain -->
    <CoscineFormGroup
      :mandatory="true"
      label-for="Domain"
      :label="$t('resourceType.gitlab.domainLabel')"
      :is-loading="isLoading"
      type="input"
    >
      <b-form-input
        id="Domain"
        v-model="v$.gitlabInformation.domain.$model"
        :state="
          v$.gitlabInformation.domain.$dirty
            ? !v$.gitlabInformation.domain.$error
            : null
        "
        :placeholder="$t('resourceType.gitlab.domain')"
        required
      />

      <div class="invalid-tooltip">
        {{ $t("resourceType.gitlab.domainInvalidTooltip") }}
      </div>
    </CoscineFormGroup>

    <!-- Access Token -->
    <CoscineFormGroup
      :mandatory="true"
      label-for="AccessToken"
      :label="$t('resourceType.gitlab.accessTokenLabel')"
      :is-loading="isLoading"
      type="input"
      info
    >
      <b-form-input
        id="AccessToken"
        v-model="v$.gitlabInformation.accessToken.$model"
        :state="
          v$.gitlabInformation.accessToken.$dirty
            ? !v$.gitlabInformation.accessToken.$error &&
              isGitlabConnectionSuccessful
            : null
        "
        :placeholder="$t('resourceType.gitlab.accessToken')"
        required
      />
      <div class="invalid-tooltip">
        {{ $t("resourceType.gitlab.accessTokenInvalidTooltip") }}
      </div>

      <template #popover>
        {{ $t("resourceType.gitlab.accessTokenInfoPopover") }}
        <b-link
          :href="$t('resourceType.gitlab.accessTokenInfoPopoverUrl').toString()"
          target="_blank"
          >{{ $t("default.help") }}
        </b-link>
      </template>
    </CoscineFormGroup>

    <CoscineFormGroup>
      <b-button
        variant="primary"
        class="d-inline-block"
        :disabled="
          !(
            v$.gitlabInformation.domain.$dirty &&
            !v$.gitlabInformation.domain.$invalid &&
            v$.gitlabInformation.accessToken.$dirty &&
            !v$.gitlabInformation.accessToken.$invalid
          )
        "
        @click="verifyDomainAndToken(false)"
      >
        {{ $t("resourceType.gitlab.verifyConnection") }}
      </b-button>
    </CoscineFormGroup>

    <!-- GitLab Project -->
    <CoscineFormGroup
      :mandatory="true"
      label-for="GitLabProject"
      :label="$t('resourceType.gitlab.projectLabel')"
      :is-loading="isLoading"
      type="input"
    >
      <multiselect
        id="GitLabProject"
        v-model="gitlabInformation.project"
        :options="gitlabProjects ?? []"
        :multiple="false"
        :hide-selected="false"
        label="name"
        track-by="name"
        :show-labels="false"
        :placeholder="$t('resourceType.gitlab.project')"
        select-label=""
        selected-label=""
        deselect-label=""
        :disabled="!isGitlabConnectionSuccessful"
        @update:modelValue="setSelectedGitLabProject"
      >
        <template #noResult>
          {{ $t("page.createResource.multiselect.noResults") }}
        </template>
        <template #noOptions>
          {{ $t("page.createResource.multiselect.noOptions") }}
        </template>
      </multiselect>
    </CoscineFormGroup>

    <!-- GitLab Branch -->
    <CoscineFormGroup
      :mandatory="true"
      label-for="GitLabBranch"
      :label="$t('resourceType.gitlab.referenceLabel')"
      :is-loading="isLoading"
      type="input"
    >
      <multiselect
        id="GitLabBranch"
        v-model="v$.gitlabInformation.branch.$model"
        :options="gitlabBranches ?? []"
        :multiple="false"
        :hide-selected="false"
        label="name"
        track-by="name"
        :show-labels="false"
        :placeholder="$t('resourceType.gitlab.reference')"
        select-label=""
        selected-label=""
        deselect-label=""
        :disabled="!(isGitlabConnectionSuccessful && gitlabInformation.project)"
        @update:modelValue="setSelectedGitLabReference"
      >
        <template #noResult>
          {{ $t("page.createResource.multiselect.noResults") }}
        </template>
        <template #noOptions>
          {{ $t("page.createResource.multiselect.noOptions") }}
        </template>
      </multiselect>

      <template #hint>
        <span
          v-if="gitlabInformation.branch && !gitlabInformation.branch.canPush"
          class="text-danger"
        >
          {{
            $t("resourceType.gitlab.cantPush", {
              branch: gitlabInformation.branch?.name,
            })
          }}
        </span>
      </template>
    </CoscineFormGroup>

    <CoscineFormGroup>
      <b-form-checkbox
        id="GitlabTos"
        v-model="isGitlabTosChecked"
        @update:modelValue="setGitlabTos"
      >
        {{ $t("resourceType.gitlab.tos") }}
        <span id="mandatory" />
      </b-form-checkbox>
    </CoscineFormGroup>
  </div>
</template>

<script lang="ts" setup>
// import the store for current module
import useResourceStore from "../../../store";
import useNotificationStore from "@/store/notification";
import type { GitlabInformation } from "@/modules/resource/types";

import { useVuelidate, type ValidationArgs } from "@vuelidate/core";
import {
  and,
  helpers,
  integer,
  minValue,
  required,
  url,
} from "@vuelidate/validators";
import { isNumber } from "lodash";
import type {
  GitlabBranchDto,
  GitlabProjectDto,
  ResourceForCreationDto,
  ResourceTypeOptionsForCreationDto,
} from "@coscine/api-client/dist/types/Coscine.Api";

import { useI18n } from "vue-i18n";
const i18n = useI18n();

const isHttpsUrl = (value: string) =>
  !helpers.req(value) || value.startsWith("https://");
const isValidGitLabUrl = and(url, isHttpsUrl);

const resourceForCreation = defineModel<ResourceForCreationDto>({
  required: true,
});

const resourceStore = useResourceStore();
const notificationStore = useNotificationStore();

const gitlabInformation = ref({
  domain: "",
  accessToken: "",
  project: null,
  branch: null,
} as GitlabInformation);

const state = reactive({
  gitlabInformation,
});
const rules = {
  gitlabInformation: {
    domain: { required, isValidGitLabUrl },
    accessToken: { required },
    project: { required, minValue: minValue(1), integer },
    branch: { required },
  } as ValidationArgs<GitlabInformation>,
};

const v$ = useVuelidate(rules, state);

const gitlabProjects = ref([] as GitlabProjectDto[] | null | undefined);
const gitlabBranches = ref([] as GitlabBranchDto[] | null | undefined);
const isGitlabConnectionSuccessful = ref(null as boolean | null);
const isLoading = ref(false);
const isGitlabTosChecked = ref(false);

const verifyDomainAndToken = async (suppressNotifications: boolean) => {
  gitlabProjects.value = await resourceStore.getGitlabAllProjects(
    gitlabInformation.value.domain,
    gitlabInformation.value.accessToken,
  );
  v$.value.gitlabInformation.$touch();
  if (
    gitlabProjects.value &&
    !v$.value.gitlabInformation.domain.$invalid &&
    !v$.value.gitlabInformation.accessToken.$invalid
  ) {
    isGitlabConnectionSuccessful.value = true;

    // Set the information inside the resource
    const resourceTypeOptionsForManipulationDto = {
      gitlabResourceTypeOptions: {
        repoUrl: gitlabInformation.value.domain,
        accessToken: gitlabInformation.value.accessToken,
        branch: gitlabInformation.value.branch?.name,
        projectId: gitlabInformation.value.project?.id,
        tosAccepted: isGitlabTosChecked.value,
      },
    } as ResourceTypeOptionsForCreationDto;

    resourceForCreation.value.resourceTypeOptions =
      resourceTypeOptionsForManipulationDto;

    if (!suppressNotifications) {
      // Post success notification
      notificationStore.postNotification({
        title: i18n
          .t("resourceType.gitlab.verificationToast.success.title")
          .toString(),
        body: i18n
          .t("resourceType.gitlab.verificationToast.success.body")
          .toString(),
      });
    }
  } else {
    isGitlabConnectionSuccessful.value = false;
    resourceForCreation.value.resourceTypeOptions = {};
    if (!suppressNotifications) {
      // Post failure notification
      notificationStore.postNotification({
        title: i18n
          .t("resourceType.gitlab.verificationToast.failure.title")
          .toString(),
        body: i18n
          .t("resourceType.gitlab.verificationToast.failure.body")
          .toString(),
        variant: "warning",
      });
    }
  }
};

const setSelectedGitLabProject = async () => {
  if (
    gitlabInformation.value.project &&
    isNumber(gitlabInformation.value.project.id)
  ) {
    gitlabBranches.value = await resourceStore.getGitlabBranchesForProject(
      gitlabInformation.value.project.id,
      gitlabInformation.value.domain,
      gitlabInformation.value.accessToken,
    );
  }
  // Set the information inside the resource
  if (
    resourceForCreation.value.resourceTypeOptions?.gitlabResourceTypeOptions
  ) {
    resourceForCreation.value.resourceTypeOptions.gitlabResourceTypeOptions.projectId =
      gitlabInformation.value.project?.id ?? -1;
  }
};

const setSelectedGitLabReference = () => {
  // Set the information inside the resource
  if (
    resourceForCreation.value.resourceTypeOptions?.gitlabResourceTypeOptions
  ) {
    resourceForCreation.value.resourceTypeOptions.gitlabResourceTypeOptions.branch =
      gitlabInformation.value.branch?.name ?? "";
  }
};

const setGitlabTos = () => {
  // Set the information inside the resource
  if (
    resourceForCreation.value.resourceTypeOptions?.gitlabResourceTypeOptions
  ) {
    resourceForCreation.value.resourceTypeOptions.gitlabResourceTypeOptions.tosAccepted =
      isGitlabTosChecked.value;
  }
};

const initTabContent = async () => {
  isLoading.value = true;
  if (
    resourceForCreation.value.resourceTypeOptions?.gitlabResourceTypeOptions &&
    resourceForCreation.value.resourceTypeOptions.gitlabResourceTypeOptions
      .repoUrl &&
    resourceForCreation.value.resourceTypeOptions.gitlabResourceTypeOptions
      .accessToken &&
    resourceForCreation.value.resourceTypeOptions.gitlabResourceTypeOptions
      .projectId &&
    resourceForCreation.value.resourceTypeOptions.gitlabResourceTypeOptions
      .branch &&
    resourceForCreation.value.resourceTypeOptions.gitlabResourceTypeOptions
      .tosAccepted
  ) {
    // A resource type has been selected, but the resource's properties are unset. Set the values.
    const resourceTypeOptions =
      resourceForCreation.value.resourceTypeOptions.gitlabResourceTypeOptions;
    gitlabInformation.value.domain = resourceTypeOptions.repoUrl;
    gitlabInformation.value.accessToken = resourceTypeOptions.accessToken;
    v$.value.gitlabInformation.$validate();
    await verifyDomainAndToken(true);
    if (gitlabProjects.value) {
      gitlabInformation.value.project =
        gitlabProjects.value.find(
          (p) => p.id === resourceTypeOptions.projectId,
        ) ?? null;
      await setSelectedGitLabProject();
      if (gitlabBranches.value) {
        gitlabInformation.value.branch =
          gitlabBranches.value.find(
            (r) => r.name === resourceTypeOptions.branch,
          ) ?? null;
        setSelectedGitLabReference();
      }
    }
    isGitlabTosChecked.value = resourceTypeOptions.tosAccepted;
  }
  isLoading.value = false;
};

initTabContent();
</script>

<style scoped>
#mandatory:after {
  content: " *";
  color: var(--bs-form-invalid-color);
}
</style>
